; note that this code expects the operators
; to be the actual functions, not text symbols

(define (make-exp op left right)
  (list op left right))

(define (operator exp)
  (car exp))

(define (left exp)
  (cadr exp))

(define (right exp)
  (caddr exp))

(define (eval-expr exp)
  (if (not (pair? exp))
      exp
      ((operator exp)
       (eval-expr (left exp))
       (eval-expr (right exp)))))

(define a (make-exp + 1 2))            ; 1+2=3
(define b (make-exp * a 3))            ; (1+2)*3 = 9
(define c (make-exp / a (make-exp + 3 4)))  ; (1+2)/(3+4) = 3/7
(define d (make-exp * c (make-exp / 1 c)))  ; c * (1/c) = 1

(eval-expr a)  ; 1+2=3
(eval-expr b)  ; (1+2)*3 = 9
(eval-expr c)  ; (1+2)/(3+4) = 3/7
(eval-expr d)  ; c * (1/c) = 1